; GX[hj (C)NCS (for PC-9801/2DD)p
; C[`

%include 'hoot.inc'

DRIVERSEG	equ	0x2000			; zuZOg

		ORG	0xd000
		USE16
		CPU	186

start:		cli
		xor	ax,ax
		mov	ss,ax
		mov	sp,ax
		mov	es,ax
		mov	ax,DRIVERSEG
		mov	ds,ax

		; hoot hCoo^
		mov	word [es:0x7f*4+0],vect_7f
		mov	[es:0x7f*4+2],cs
		mov	es,ax

		mov	ax,cs
		mov	ds,ax
		mov	ax,0x0856		; FM荞ݑ݃`FbN
		call	ax
		jb	mainloop
		mov	dl,0x40			; Timer-B
		mov	ax,0x09ed		; Timer-Bݒ
		call	ax
		mov	ax,0x09c7		; FM荞݃tbN
		call	ax
		call	sound_di		; TEh荞݋֎~

		mov	word [0x03af],mdata_table	; e[u

mainloop:	mov	ax,0x9801		; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98VX::Play  [hO
; inp8(HOOTPORT) = 1  PC98VX::Play  [h
; inp8(HOOTPORT) = 2  PC98VX::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .select
		cmp	al,HP_LOADPLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .stop
.ed:		pop	ds
		popa
		iret

.play:		mov	dx,HOOTPORT+4
		in	al,dx
.playx:		mov	bx,0x0391		; ȃf[^Zbg AL=Ȕԍ
		call	bx
		call	sound_ei		; tJn
		jmp	short .ed

.stop:		xor	al,al			; ~R[h
		jmp	short .playx

;
; If[^ɂĂяoGgƒ~R[hύX
;
.select:	call	sound_di		; 荞݋֎~
		jmp	short .ed		; ȊO

; TEh荞(INT5)֎~
sound_di:	cli
		in	al,0x0a
		or	al,0x10
		out	0x0a,al
		sti
		ret

; TEh荞(INT5)
sound_ei:	cli
		in	al,0x0a
		and	al,0xef
		out	0x0a,al
		sti
		ret

mdata_table:	db	0x00, 0x00		; 00 t~
		db	0x00, 0x00
		db	0x00, 0x00
		db	0x00, 0x00
		db	0x00, 0x00
		db	0x00, 0x00

		db	0x01, 0x00		; 01 I[vjO / BGM#01
		db	0x01, 0x01
		db	0x01, 0x02
		db	0x01, 0x03
		db	0x01, 0x03
		db	0x01, 0x03

		db	0x01, 0x08		; 02 GfBO / BGM#02
		db	0x01, 0x09
		db	0x01, 0x0a
		db	0x01, 0x0b
		db	0x01, 0x0c
		db	0x01, 0x0c

		db	0x01, 0x08		; 03 KCA̖̓j[
		db	0x01, 0x09
		db	0x01, 0x0a
		db	0x01, 0x0b
		db	0x01, 0x0b
		db	0x01, 0x0b

		db	0x01, 0x10		; 04 KCA̖ 
		db	0x01, 0x11
		db	0x01, 0x12
		db	0x00, 0x00
		db	0x00, 0x00
		db	0x00, 0x00

		db	0x01, 0x00		; 05 KCA̖ BGM #00
		db	0x01, 0x01
		db	0x00, 0x00
		db	0x01, 0x03
		db	0x01, 0x07
		db	0x01, 0x07

		db	0x01, 0x08		; 06 KCA̖ BGM #02
		db	0x01, 0x09
		db	0x00, 0x00
		db	0x01, 0x0b
		db	0x01, 0x0b
		db	0x01, 0x0b

		db	0x01, 0x10		; 07 KCA̖ BGM #03
		db	0x01, 0x11
		db	0x00, 0x00
		db	0x01, 0x13
		db	0x01, 0x14
		db	0x01, 0x14

		db	0x02, 0x00		; 08 ʉ
		db	0x02, 0x00
		db	0x01, 0x18
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 09 ʉ
		db	0x02, 0x00
		db	0x01, 0x19
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0A ʉ
		db	0x02, 0x00
		db	0x01, 0x1a
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0B ʉ
		db	0x02, 0x00
		db	0x01, 0x1b
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0C ʉ
		db	0x02, 0x00
		db	0x01, 0x1c
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0D ʉ
		db	0x02, 0x00
		db	0x01, 0x1d
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0E ʉ
		db	0x02, 0x00
		db	0x01, 0x1e
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 0F ʉ
		db	0x02, 0x00
		db	0x01, 0x1f
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 10 ʉ
		db	0x02, 0x00
		db	0x01, 0x20
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 11 ʉ
		db	0x02, 0x00
		db	0x01, 0x21
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 12 ʉ
		db	0x02, 0x00
		db	0x01, 0x22
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 13 ʉ
		db	0x02, 0x00
		db	0x01, 0x28
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 14 ʉ
		db	0x02, 0x00
		db	0x01, 0x29
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 15 ʉ
		db	0x02, 0x00
		db	0x01, 0x2a
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 16 ʉ
		db	0x02, 0x00
		db	0x01, 0x2b
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 17 ʉ
		db	0x02, 0x00
		db	0x01, 0x2c
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 18 ʉ
		db	0x02, 0x00
		db	0x01, 0x2d
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 19 ʉ
		db	0x02, 0x00
		db	0x01, 0x2e
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1A ʉ
		db	0x02, 0x00
		db	0x01, 0x2f
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1B ʉ
		db	0x02, 0x00
		db	0x01, 0x30
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1C ʉ
		db	0x02, 0x00
		db	0x01, 0x34
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1D ʉ
		db	0x02, 0x00
		db	0x01, 0x35
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1E ʉ
		db	0x02, 0x00
		db	0x01, 0x36
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 1F ʉ
		db	0x02, 0x00
		db	0x01, 0x37
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 20 ʉ
		db	0x02, 0x00
		db	0x01, 0x38
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 21 ʉ
		db	0x02, 0x00
		db	0x01, 0x3c
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

		db	0x02, 0x00		; 22 ʉ
		db	0x02, 0x00
		db	0x01, 0x3d
		db	0x02, 0x00
		db	0x02, 0x00
		db	0x02, 0x00

